/*Ŀ
 ݳ Program Name: TEST.PRG          Copyright: Gallagher Computing Corp. 
 ݳ Date Created: 12/17/92           Language: Clipper 5.0               
 ݳ Time Created: 20:45:19             Author: Kevin S Gallagher         
 ݳ      Purpose: Test Funcky's Notepad                                  
 ݳ                                                                      
 ݳ                                                                      
 ݳ                                                                      
 
            */

#define TESTING

#ifdef JUNK
static nTR:=5, nTC:=5, nBR:=20, nBC:=75
#endif

#include "nPad.h"

#ifdef TESTING
function main
    local X:="", myName:= " Kevin ",oldcursor:=setcursor(0)
    local oldscrn:=savescreen(0,0,maxrow(),maxcol())
    SETCANCEL( FALSE )                           // Remapped
    cls(127,"")                                 // paint backdrop
    aReplicate( 0, 0, " ", 80, MAGENTA )         // Top status bar
    aReplicate(MR, 0, " ", 80, MAGENTA )         // Bottom status bar

    print(MR,50,"Line:       Col:",STATUS_COLOR) // Pad's Row/Col

    box(8,18,14,55,BOXFRAMES[3],31)
    @10,20 say "This is a test of FUNcky's NotePad" color "w+/b"
    @11,22 say "Under control of an UDCommand"      color "w+/b"
    @12,23 say "Press any key to try it out!"       color "gr+/b"
    inkey(0)
    setcursor(1)

    // execute the notepad
    NOTEPAD X TOP 5                                                        ;
              LEFT 3                                                       ;
              BOTTOM 15                                                    ;
              RIGHT 76                                                     ;
              BOXCOLOR 26                                                  ;
              BOXTYPE 1                                                    ;
              BUFFERSIZE 5000                                              ;
              MAXLINES 90                                                  ;
              WRAPCOLUMN 80                                                ;
              SETTABS 4                                                    ;
              BOXTITLE " MyFile "                                          ;
              RSCRN                                                        ;
              EDITME { | b | KEVIN(b) }                                    ;
              FILE                                                         ;
              FILENAME "C:\AUTOEXEC.BAT"

    /* 
       At this point the declared variable can be evaluate.
       It is up to you as a programmer to setup return codes!
    */

    @maxrow(),0 say PADC("WHEN READY PRESS ANY KEY TO EXIT",80)  color "w+/n"
    inkey(20)
    setcursor( oldcursor )
    restscreen(0,0,maxrow(),maxcol(),oldscrn)
    @0,0 say PADC("FUNCKY II multi-language library (c) dLesko", 80)
    @0,0 say PADC("UDCommand created by Kevin S. Gallagher",     80)
return nil
#endif


function KEVIN( o )
    local nKey, InsertMode:= .F., cBlockBuf:="", nRow:=0, nCol:=0, nEnd:=0

    NO_DEBUG()

    csrtype( 0 )
    
    o:EolChar    := NO_SHOW_CR
    o:LineLength := LAST_COL
    o:Color      := PAD_COLOR
    o:BlockColor := PAD_BLOCK

    DO WHILE ( TRUE )
        o:Display()
        o:Repaint()
        if LEN( o:Block ) <> 0
            cBlockBuf := o:Block
        endif
        csrput( o:ScrRow, o:ScrCol )
        print(MR,56, PADR(LSTRINT( npCsrRow( o ) ),4), 95 )
        print(MR,67, PADR(LSTRINT( npCsrCol( o ) ),4), 95 )

        nEnd     := npGetChar( o )
        nKey     := inkey(0)
        nEnd     := npGetChar( o )
        nRow     := o:ScrRow
        nCol     := o:ScrCol

        DO CASE
            CASE( nKey == CENTER_LINE )  ;  npCenter( o )
            CASE( nKey == DEL_LINE )     ;  npDeleteLine( o )
            CASE( nKey == BACKSPACE )    ;  o:BackSpace()
            CASE( nKey == DEL )          ;  o:Delete() 
            CASE( nKey == CTRLLEFT )     ;  o:WordLeft()
            CASE( nKey == CTRLRIGHT )    ;  o:WordRight()
            CASE( nKey == PGUP )         ;  o:PageUp()
            CASE( nKey == PGDN )         ;  o:PageDown()
            CASE( nKey == HOME )         ;  o:CsrCol := HOME_COL
            CASE( nKey == END )          ;  o:CsrCol := LAST_COL
            CASE( nKey == LEFTARROW )    ;  o:CsrIndex--
            CASE( nKey == RIGHTARROW )   ;  o:CsrIndex++
            CASE( nKey == UPARROW )      ;  o:CsrRow--
            CASE( nKey == DOWNARROW )    ;  o:CsrRow++
            CASE( nKey == ESC )          ;  return NIL
            CASE( nKey == F1 )           ;  help()
            CASE ( nKey >= 32 AND nKey <= 255 )
            IF InsertMode .AND. nEnd <> nHardRet
                npOverWrite( o, nKey )
            ELSE
                npInsert( o, nKey )
            ENDIF
            CASE( nKey == ENTER )
                IF( InsertMode )
                    o:OverWrite( nKey )
                ELSE
                    o:Insert( nKey )
                ENDIF
            CASE( nKey == INS )
                InsertMode := (! InsertMode)
                csrtype( IIF(InsertMode, 4, 0) )
            CASE( nKey == MARK_BLOCK )           /* ALT-B */
                if LEN( o:Block ) == 0
                    o:BeginMark()
                else
                    o:EndMark()
                    o:UnMark()
                endif
            CASE( nKey == CUT_BLOCK )            /* ALT-C */
                cBlockBuf:= o:Block
                o:Block  := NIL
            CASE( nKey == PASTE_BLOCK )          /* ALT-C */
                if LEN( cBlockBuf ) <> 0
                    nCol:= o:ScrCol
                    o:InsertText( cBlockBuf )
                    csrput(o:CsrRow,nCol + LEN( cBlockBuf ) )
                endif
        ENDCASE
    ENDDO
return NIL


function help
    local oldscrn := savescreen(5,3,15,76), oldcur := setcursor(0)
    /*************************
    * Very simple help message
    */
    dispbox(5,3,15,76,BOXFRAMES[2],"N/BG")
    @ 6,6 say "[Press any key to exit Help]"                    color "N/BG"
    @ 7,6 say "This is a simple demo of Funcky's notepad"       color "N/BG"
    @ 8,6 say "[INS]   - Toggle Insert/Overstrike"              color "N/BG"
    @ 9,6 say "ALT-B   - Start/End text block"                  color "N/BG"
    @10,6 say "ALT-C   - Cut block"                             color "N/BG"
    @11,6 say "ALT-D   - Delete current line"                   color "N/BG"
    @12,6 say "ALT-I   - Insert block at current position"      color "N/BG"
    @14,6 say "Other keys like [Ctrl-LeftArrow] work too.."     color "N/BG"
    inkey(0)
    restscreen(5,3,15,76,oldscrn)
    setcursor( oldcur )
return nil


 ***************************************************************************
 ***************************************************************************
 ***************************************************************************
 ***************************************************************************